//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Backpropogation.h"
#include "FuncDisplay.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

float TForm1::sigmoid(float x){
	if(x<-200)return 0;
	if(x>200)return 1;
	return (1/(1+exp(-x)));
}

float TForm1::sig(float x){
	return sigmoid(x)-0.5;
}

float TForm1::sig_diff(float x){
	float s;
	s=sigmoid(x);
	return (1-s)*s;
}

void TForm1::propogate(){
	int x,y;
	//input layer
	for(x=0;x<3;x++){
		layerinp[x]->sum=0;
		for(y=0;y<3;y++){
			layerinp[x]->sum+=layerinp[x]->w[y]*in[y];
		}
		layerinp[x]->out=sig(layerinp[x]->sum);
	}
	//output layer
	for(x=0;x<3;x++){
		layerout[x]->sum=0;
		for(y=0;y<3;y++){
			layerout[x]->sum+=layerout[x]->w[y]*layerinp[x]->out;
		}
		layerout[x]->out=sig(layerout[x]->sum);
	}
}

void TForm1::backprop(){
	int x,y;
	//DELTA
	//output layer
	for(x=0;x<3;x++){
		layerout[x]->delta=expectedout[x]-layerout[x]->out;
		layerout[x]->delta*=sig_diff(layerout[x]->sum);
	}
	//input layer
	for(x=0;x<3;x++){
		layerinp[x]->delta=0;
		for(y=0;y<3;y++){
			layerinp[x]->delta+=layerout[y]->w[x]*layerout[y]->delta;
		}
		layerinp[x]->delta*=sig_diff(layerinp[x]->sum);
	}
	//CHANGE W
	//input layer
	for(x=0;x<3;x++)for(y=0;y<3;y++){
		layerinp[x]->w[y]+=etha*layerinp[x]->delta*in[y];
	}
	//output layer
	for(x=0;x<3;x++)for(y=0;y<3;y++){
		layerout[x]->w[y]+=etha*layerout[x]->delta*layerinp[y]->out;
	}
}

void TForm1::display(){
	Form2->Canvas->Pen->Color=0x0000FF;
	for(int x=0;x<10;x++){
		Form2->Canvas->MoveTo(displaypos,x*50+50+layerout[x]->out*50);
		Form2->Canvas->LineTo(displaypos+1,x*50+50+layerout[x]->out*50);
	}
	displaypos++;
}

void TForm1::guiupdate(){
	AnsiString s;
	s.sprintf("%f",in[0]);Edit12->Text=s;
	s.sprintf("%f",in[1]);Edit13->Text=s;
	s.sprintf("%f",in[2]);Edit27->Text=s;

	s.sprintf("%f",expectedout[0]);Edit28->Text=s;
	s.sprintf("%f",expectedout[1]);Edit29->Text=s;
	s.sprintf("%f",expectedout[2]);Edit30->Text=s;

	s.sprintf("%f",layerinp[0]->w[0]);Edit1->Text=s;
	s.sprintf("%f",layerinp[0]->w[1]);Edit2->Text=s;
	s.sprintf("%f",layerinp[0]->w[2]);Edit3->Text=s;
	s.sprintf("%f",layerinp[1]->w[0]);Edit4->Text=s;
	s.sprintf("%f",layerinp[1]->w[1]);Edit5->Text=s;
	s.sprintf("%f",layerinp[1]->w[2]);Edit6->Text=s;
	s.sprintf("%f",layerinp[2]->w[0]);Edit7->Text=s;
	s.sprintf("%f",layerinp[2]->w[1]);Edit8->Text=s;
	s.sprintf("%f",layerinp[2]->w[2]);Edit9->Text=s;
	s.sprintf("%f",layerinp[0]->out);Edit21->Text=s;
	s.sprintf("%f",layerinp[1]->out);Edit22->Text=s;
	s.sprintf("%f",layerinp[2]->out);Edit23->Text=s;

	s.sprintf("%f",layerout[0]->w[0]);Edit10->Text=s;
	s.sprintf("%f",layerout[0]->w[1]);Edit11->Text=s;
	s.sprintf("%f",layerout[0]->w[2]);Edit14->Text=s;
	s.sprintf("%f",layerout[1]->w[0]);Edit15->Text=s;
	s.sprintf("%f",layerout[1]->w[1]);Edit16->Text=s;
	s.sprintf("%f",layerout[1]->w[2]);Edit17->Text=s;
	s.sprintf("%f",layerout[2]->w[0]);Edit18->Text=s;
	s.sprintf("%f",layerout[2]->w[1]);Edit19->Text=s;
	s.sprintf("%f",layerout[2]->w[2]);Edit20->Text=s;
	s.sprintf("%f",layerout[0]->out);Edit24->Text=s;
	s.sprintf("%f",layerout[1]->out);Edit25->Text=s;
	s.sprintf("%f",layerout[2]->out);Edit26->Text=s;
}

float TForm1::randweight(){
	float num;
	num=(floor(Random(100)))/1000;
	return num;
}

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner): TForm(Owner){
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	int x,y;

	for(x=0;x<3;x++){
		layerinp[x]=new neu();
		layerinp[x]->out=0;
		for(y=0;y<3;y++)layerinp[x]->w[y]=randweight();
	}
	for(x=0;x<3;x++){
		layerout[x]=new neu();
		layerout[x]->out=0;
		for(y=0;y<3;y++)layerout[x]->w[y]=randweight();
	}
	for(x=0;x<3;x++){
		in[x]=0; expectedout[x]=0;
	}

	expectedout[0]=0.1;expectedout[1]=0.2;expectedout[2]=0.3;
	in[0]=1.0;in[1]=2.0;in[2]=3.0;

	//learning rate
	etha=0.1;
	displaypos=1;
	examplec=0;
	propogate();
	guiupdate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	in[0]=Edit12->Text.ToDouble();
	in[1]=Edit13->Text.ToDouble();
	in[2]=Edit27->Text.ToDouble();
	propogate();
	guiupdate();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Destroy(TObject *Sender)
{
	int x;
	for(x=0;x<3;x++){delete layerinp[x];}
	for(x=0;x<3;x++){delete layerout[x];}
}
//---------------------------------------------------------------------------

//TRAIN
void __fastcall TForm1::Button2Click(TObject *Sender)
{
	int x,y,z;
	AnsiString s;

	for(z=0;z<10000;z++){
		propogate();
		backprop();
	}
	guiupdate();
}
//---------------------------------------------------------------------------

//Multi train
void __fastcall TForm1::Button3Click(TObject *Sender)
{
	int x,y,z;
	AnsiString s;

	for(z=0;z<10000;z++)for(y=0;y<2;y++){
		for(x=0;x<3;x++){
			in[x]=minta[y].input[x];
			expectedout[x]=minta[y].expected[x];
		}
		propogate();
		backprop();
	}
	guiupdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar1Change(TObject *Sender)
{
	float pos;
	AnsiString s;
	pos=TrackBar1->Position;
	pos-=50;pos/=5;
	s.sprintf("%f",pos);Edit12->Text=s;
	in[0]=pos;propogate();guiupdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar2Change(TObject *Sender)
{
	float pos;
	AnsiString s;
	pos=TrackBar2->Position;
	pos-=50;pos/=5;
	s.sprintf("%f",pos);Edit13->Text=s;
	in[1]=pos;propogate();guiupdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TrackBar3Change(TObject *Sender)
{
	float pos;
	AnsiString s;
	pos=TrackBar3->Position;
	pos-=50;pos/=5;
	s.sprintf("%f",pos);Edit27->Text=s;
	in[2]=pos;propogate();guiupdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
	int x;
	for(x=0;x<3;x++){
		in[x]=minta[examplec].input[x];
		expectedout[x]=minta[examplec].expected[x];
	}
	examplec++;
	guiupdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
	examplec=0;  guiupdate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
	float f;
	AnsiString s;
	f=Edit31->Text.ToDouble();
	s.sprintf("%f",sig_diff(f));
	Edit32->Text=s;
}
//---------------------------------------------------------------------------

